local _, L = ...;
local addOnName = ...

------Slashcommands
SLASH_RELOADUI1 = "/rl"
SLASH_RELOADUI2 = "/re"
SlashCmdList.RELOADUI = ReloadUI

SLASH_FRAMESTK1 = "/fs"; -- new slash command for showing framestack tool
	SlashCmdList.FRAMESTK = function()
		LoadAddOn("Blizzard_DebugTools");
		FrameStackTooltip_Toggle();
end

SLASH_FPS1 = "/fps"; -- new slash command for showing fps tool
SlashCmdList.FPS = function()
ToggleFramerate();	
end

SLASH_TNS1 = "/tns"
SlashCmdList.TNS =   function() TNS_Command() end

function TNS_Command()                                --Buggy needs to be commanded 3x
	InterfaceOptionsFrame_OpenToCategory(addOnName);
	InterfaceOptionsFrame_OpenToCategory(addOnName);
	InterfaceOptionsFrame_OpenToCategory(addOnName);
end



-------Warm welcomes and chat improvement
function sayhello()
    local hex = "00ccff";
	local prefix = string.format("|cff%s%s|r", hex:upper(), "Tweaks n Stuff:");	
	
	
	if string.match(UnitName("player"), "Iyea")~=nil then
		DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, "Hey Plep!"));
	elseif string.match(UnitName("player"), "Luckii")~=nil then
		DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, "Hey Plep!"));
	elseif string.match(UnitName("player"), "Regen")~=nil then
		DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, "Hey Plep!"));
	else
		DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, L.WarmWelcomes, UnitName("player").."!"));
	end
		
	
end

sayhello();



for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false);
end


----------------------------Timer Section

local timer = 0 


local f = CreateFrame("Frame")
f:SetScript("OnUpdate", function(self, elapsed)
       timer = timer + elapsed
    if timer >= 0.5 then                                  ---interval (in seconds)
        
		timer = 0
				
		durabilitycheck()		
		if rounded<=TNSDataChar.repair_percent
		then repair_bool=true 
		HS_TextMessage(L.DurabilityWarning)		
		end
    end   
		
		
end)


----------------------------Timer section
durabilitycheck = function() 

function scanAll()
	equipped,bags,cost,per,current,maximum,total,_ = 0,0,0,1;
	_curr,_max,_per,_perSlot,_AvPercent = 0,0,1,nil,1;

	for slot=1, 18 do
		if (GetInventoryItemID("player", slot)) then
			current,maximum = GetInventoryItemDurability(slot); -- durability values
			if (current) and (maximum>0) and (current<maximum) then
								equipped = equipped + tonumber(cost or 0);
				_curr,_max = _curr+current,_max+maximum;
				per = current/maximum;
				if (per<_per) then
					_per,_perSlot = per,slot;
				end
			end
		end
	end

	if (_max>0) then
		_AvPercent = _curr/_max;
	end

	return total,equipped,bags,_AvPercent*100,_per*100,_perSlot;

	end

	total,equipped,bags,_AvPercent,_per,_perSlot = scanAll()


	rounded = floor(_AvPercent)

	--print(rounded)


end


TextFrame = CreateFrame("Frame");
--TextFrame:ClearAllPoints();
TextFrame:SetHeight(120);
TextFrame:SetWidth(400);
TextFrame:SetScript("OnUpdate", HS_TextFrame_OnUpdate)
TextFrame:Hide();
TextFrame.text = TextFrame:CreateFontString(nil, "BACKGROUND", nil); --PVPInfoTextFont before

function HS_TextMessage(message)

	if not TNSDataChar then 
		TextFrame.text:SetFont("Fonts\\FRIZQT__.TTF",22,"THICKOUTLINE");
	else 
		TextFrame.text:SetFont("Fonts\\FRIZQT__.TTF",TNSDataChar.textsize,"THICKOUTLINE");
	end

	TextFrame.text:SetAllPoints();
	TextFrame:SetPoint("CENTER",tns_anchor, 0); --	Debug TextFrame:SetPoint("CENTER",0,0);
	
	
	TextFrame.text:SetText(message);
	TextFrame.text:SetTextColor(1, 0, 0, 1);
	TextFrame:SetAlpha(1);
	TextFrame:Show();
	if TNSDataChar.Active==false then 
		TextFrame:Hide();

	else
		local inLockdown = InCombatLockdown()
		if   TNSDataChar.Combat==true then 
			if inLockdown==true then TextFrame:Hide(); end  
		end
		HS_TextFrameTime = GetTime();
	end

end


------------------------------------------------
---------------	 Option Settings ---------------
------------------------------------------------

TNS = {} 

local vars = CreateFrame("FRAME") -- Variables
vars:RegisterEvent("ADDON_LOADED") --RegisterAddonLoad


-- Toast Frame
tns_anchor = CreateFrame("FRAME")
tns_anchor:SetPoint("CENTER",UIParent, nil)
tns_anchor:SetWidth(302)
tns_anchor:SetHeight(70)
tns_anchor:SetMovable(true)
tns_anchor:SetUserPlaced(false)
tns_anchor:SetClampedToScreen(true)
tns_anchor:RegisterForDrag("LeftButton")
tns_anchor:SetScript("OnDragStart", tns_anchor.StartMoving)
tns_anchor:SetScript("OnDragStop", tns_anchor.StopMovingOrSizing)
tns_anchor:Hide()

-- Toast Texture
tns_anchor_texture = tns_anchor:CreateTexture(nil, "BACKGROUND")
tns_anchor_texture:SetTexture("Interface\\AddOns\\Tweaks n Stuff\\anchorframe")
tns_anchor_texture:SetPoint("CENTER", tns_anchor, "CENTER", 0, 0)
tns_anchor.texture = tns_anchor_texture

-- Toast Title
tns_anchor_title = tns_anchor:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
tns_anchor_title:SetPoint("TOPLEFT", 23, -10)
tns_anchor_title:SetWidth(260)
tns_anchor_title:SetHeight(16)
tns_anchor_title:SetJustifyV("TOP")
tns_anchor_title:SetJustifyH("LEFT")

-- Toast Text
tns_anchor_text = tns_anchor:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
tns_anchor_text:SetPoint("TOPLEFT", tns_anchor_title, 1, -23)
tns_anchor_text:SetWidth(258)
tns_anchor_text:SetHeight(32)			
tns_anchor_text:SetJustifyV("TOP")
tns_anchor_text:SetJustifyH("LEFT")

-- Toast Reset Button
tns_anchor_reset_button = CreateFrame("Button", nil, tns_anchor, "OptionsButtonTemplate")
tns_anchor_reset_button:SetPoint("BOTTOMLEFT", tns_anchor, "BOTTOMLEFT", 5, 6)
tns_anchor_reset_button:SetWidth(146)
tns_anchor_reset_button:SetScript("OnClick",function()
	tns_anchor:ClearAllPoints()
	tns_anchor:SetPoint("CENTER", UIParent, "CENTER", 0, 256)
	
end)

-- Toast Lock Button
tns_anchor_lock_button = CreateFrame("Button", nil, tns_anchor, "OptionsButtonTemplate")
tns_anchor_lock_button:SetPoint("BOTTOMRIGHT", tns_anchor, "BOTTOMRIGHT", -5, 6)
tns_anchor_lock_button:SetWidth(146)
tns_anchor_lock_button:SetScript("OnClick",function()
	TNSDataChar.xPos = tns_anchor:GetLeft()
	TNSDataChar.yPos = tns_anchor:GetTop()
	InterfaceOptionsFrame_OpenToCategory(addOnName)
	tns_anchor:Hide()
	tns_anchor_lock_button:Hide()
	tns_anchor_reset_button:Hide()
	tns_anchor_title:SetText("")
	tns_anchor_text:SetText("")
	tns_anchor:EnableMouse(false)
end)


-- Load Variables
vars:SetScript("OnEvent",function(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == "Tweaks n Stuff" then
        if TNSDataChar == nil then
            TNSDataChar = {
        
				Active = true, -- Toggle Active
				Combat = false, -- Toggle Combat
				xPos = 0, 
				yPos = 0,
				textsize = 22,
				repair_percent = 30
            }
        else

            if TNSDataChar.Active == nil then TNSDataChar.Active = true end -- Toggle Active
			if TNSDataChar.Combat == nil then TNSDataChar.Combat = false end -- Toggle Combat
			if TNSDataChar.xPos == nil then TNSDataChar.xPos = 0 end -- set xPos
			if TNSDataChar.yPos == nil then TNSDataChar.yPos = 0 end -- set yPos
			if TNSDataChar.textsize == nil then TNSDataChar.textsize = 22 end -- set textsize
			if TNSDataChar.repair_percent == nil then TNSDataChar.repair_percent = 30 end -- set repair_percent
		end
		TNS:Position() -- Anchor Position
		TNS:Options() -- TNS Options
		
    end
end)

-- Anchor Position
function TNS:Position()
	tns_anchor:ClearAllPoints()
	if TNSDataChar.xPos ~= 0 or TNSDataChar.yPos ~= 256 then
		tns_anchor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", TNSDataChar.xPos, TNSDataChar.yPos)
	else
		tns_anchor:SetPoint("CENTER", UIParent, "CENTER", 0, 256)
	end
end



function TNS:Options()

    local Configurationpanel = CreateFrame("FRAME", "Configurationpanel")
    Configurationpanel.name = addOnName
	InterfaceOptions_AddCategory(Configurationpanel)
	
	-------------------------- main Configurationpanel
	-- Title
    local title = Configurationpanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addOnName)
	

    -- Active CheckButton
    local check_Active = CreateFrame("CheckButton", "check_Active", Configurationpanel, "ChatConfigCheckButtonTemplate")
    check_Active:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -3, -35)
    check_Active:SetWidth(30)
	check_Active:SetHeight(30)
	check_Active.tooltip = L.EnabledDescription
    _G[check_Active:GetName().."Text"]:SetText(L.UI_Enabled)
    check_Active:SetChecked(TNSDataChar.Active)
    check_Active:SetScript("OnClick",function()
        TNSDataChar.Active = check_Active:GetChecked()
	end)   

	-- Combat CheckButton
	local check_Combat = CreateFrame("CheckButton", "check_Combat", Configurationpanel, "ChatConfigCheckButtonTemplate")
	check_Combat:SetPoint("TOPLEFT", title, "BOTTOMLEFT", -3, -65)
	check_Combat:SetWidth(30)
	check_Combat:SetHeight(30)
	check_Combat.tooltip = L.CombatHideDescription;
	_G[check_Combat:GetName().."Text"]:SetText(L_CombatHideEnabled)
	check_Combat:SetChecked(TNSDataChar.Combat)
	check_Combat:SetScript("OnClick",function()
		TNSDataChar.Combat= check_Combat:GetChecked()
	end)   


	-- textsize slider text
	local slider_fade_value = Configurationpanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	slider_fade_value:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 63, -145.5)
	slider_fade_value:SetText(TNSDataChar.textsize)
	slider_fade_value:SetJustifyH("CENTER")
	slider_fade_value:SetWidth(32)

	-- textsize slider
	local slider_fade = CreateFrame("Slider", "slider_fade", Configurationpanel, "OptionsSliderTemplate")
	slider_fade:ClearAllPoints()
	slider_fade:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 4, -130)
	slider_fade:SetMinMaxValues(8, 40)
	slider_fade:SetValue(TNSDataChar.textsize)
	slider_fade:SetValueStep(1)
	slider_fade:SetObeyStepOnDrag(true)
	slider_fade:SetOrientation("HORIZONTAL")
	_G[slider_fade:GetName() .. "Low"]:SetText("8")
	_G[slider_fade:GetName() .. "High"]:SetText("40")
	_G[slider_fade:GetName() .. "Text"]:SetText("Textsize")
	slider_fade:SetScript("OnValueChanged",function() 
		TNSDataChar.textsize = slider_fade:GetValue()
		slider_fade_value:SetText(slider_fade:GetValue())		
	end)

	-- repair_percent slider text
	local slider_repair_percent_value = Configurationpanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	slider_repair_percent_value:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 63, -205.5)
	slider_repair_percent_value:SetText(TNSDataChar.repair_percent)
	slider_repair_percent_value:SetJustifyH("CENTER")
	slider_repair_percent_value:SetWidth(32)

	-- repair_percent slider
	local slider_repair_percent = CreateFrame("Slider", "slider_repair_percent", Configurationpanel, "OptionsSliderTemplate")
	slider_repair_percent:ClearAllPoints()
	slider_repair_percent:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 4, -190)
	slider_repair_percent:SetMinMaxValues(5, 80)
	slider_repair_percent:SetValue(TNSDataChar.repair_percent)
	slider_repair_percent:SetValueStep(1)
	slider_repair_percent:SetObeyStepOnDrag(true)
	slider_repair_percent:SetOrientation("HORIZONTAL")
	_G[slider_repair_percent:GetName() .. "Low"]:SetText("8")
	_G[slider_repair_percent:GetName() .. "High"]:SetText("40")
	_G[slider_repair_percent:GetName() .. "Text"]:SetText("Repair Percent")
	slider_repair_percent:SetScript("OnValueChanged",function() 
		TNSDataChar.repair_percent = slider_repair_percent:GetValue()
		slider_repair_percent_value:SetText(slider_repair_percent:GetValue())		
	end)
	

	-- Toggle Anchor
	local button_anchor_toggle = CreateFrame("Button", nil, Configurationpanel, "OptionsButtonTemplate")
	button_anchor_toggle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 300, -385)
	button_anchor_toggle:SetText("ANCHOR")
	button_anchor_toggle:SetWidth(192)
	button_anchor_toggle:SetScript("OnClick",function()
		if tns_anchor:IsVisible() then
			TNSDataChar.xPos = tns_anchor:GetLeft()
			TNSDataChar.yPos = tns_anchor:GetTop()
			tns_anchor:Hide()
			tns_anchor_reset_button:Hide()
			tns_anchor_lock_button:Hide()
			tns_anchor_title:SetText("")
			tns_anchor_text:SetText("")
			tns_anchor:EnableMouse(false)
		else
			HideUIPanel(InterfaceOptionsFrame)
			HideUIPanel(GameMenuFrame)
			tns_anchor:Show()
			tns_anchor_reset_button:Show()
			tns_anchor_lock_button:Show()
			tns_anchor:SetAlpha(1)
			tns_anchor_title:SetAlpha(1)
			tns_anchor_text:SetAlpha(1)
			tns_anchor:EnableMouse(true)
			tns_anchor_title:SetText(MOVE_FRAME)
			tns_anchor_text:SetText("")
			tns_anchor_reset_button:SetText(RESET_POSITION)
			tns_anchor_lock_button:SetText(LOCK)
		end
	end)

	-- Reset Anchor
	local button_anchor_toggle = CreateFrame("Button", nil, Configurationpanel, "OptionsButtonTemplate")
	button_anchor_toggle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 300, -410)
	button_anchor_toggle:SetText(RESET_POSITION)
	button_anchor_toggle:SetWidth(192)
	button_anchor_toggle:SetScript("OnClick",function()
		tns_anchor:ClearAllPoints()
		tns_anchor:SetPoint("CENTER", UIParent, "CENTER", 0, 256)
	end)

	
-----------------info Configurationpanel

	local infopanel = CreateFrame("Frame")
	infopanel.name = "Info"
	infopanel.parent = addOnName

	InterfaceOptions_AddCategory(infopanel)

	local infotext = infopanel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	infotext:SetPoint("TOPLEFT", 16, -16)
	infotext:SetText("Author: Mmæ-Blackmoore")

	local sometext = infopanel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	sometext:SetPoint("TOPLEFT", infotext, "BOTTOMLEFT", 0, -8)
	sometext:SetText("Still work in progress!")
							                   
                  
end

